Agent Governance Protocol
API ReferenceExecution APIExecution

Submit action envelope

Submits an action envelope for validation and optional execution. Execution mode is controlled by the Prefer header. Fails closed on any missing or invalid prerequisite per §10.

POST
/agp/action-envelopes

Authorization

AuthorizationBearer <token>

In: header

Scope: agp.execution.read, agp.execution.write

Header Parameters

Idempotency-Key?string
Prefer?string

Request Body

application/json

TypeScript Definitions

Use the request body type in TypeScript.

Response Body

application/json

application/json

application/json

application/json

application/json

application/json

application/json

curl -X POST "https://example.com/agp/action-envelopes" \  -H "Content-Type: application/json" \  -d '{    "type": "ActionEnvelope",    "action_id": "string",    "task_id": "string",    "agent_id": "string",    "tool_id": "string",    "operation": "string",    "capability_token_ref": "string",    "decision_ref": "string",    "policy_decision_ref": "string",    "created_at": "2019-08-24T14:15:22Z"  }'
{  "type": "ActionEnvelope",  "action_id": "string",  "task_id": "string",  "agent_id": "string",  "tool_id": "string",  "operation": "string",  "parameters_hash": "string",  "allowed_parameter_ranges": {},  "capability_token_ref": "string",  "decision_ref": "string",  "policy_decision_ref": "string",  "approval_ref": "string",  "commerce_session_ref": "string",  "payment_ref": "string",  "created_at": "2019-08-24T14:15:22Z",  "governance_attestations": [    {      "agent_id": "string",      "agent_role": "executive",      "verdict": "cleared",      "conditions": [        "string"      ],      "notes": "string",      "attested_at": "2019-08-24T14:15:22Z",      "signature": {        "alg": "string",        "kid": "string",        "issuer": "string",        "issued_at": "2019-08-24T14:15:22Z",        "payload_hash": "string",        "value": "string"      }    }  ],  "signature": {    "alg": "string",    "kid": "string",    "issuer": "string",    "issued_at": "2019-08-24T14:15:22Z",    "payload_hash": "string",    "value": "string"  }}
{  "operation_id": "string",  "status": "pending",  "created_at": "2019-08-24T14:15:22Z",  "updated_at": "2019-08-24T14:15:22Z",  "status_url": "http://example.com",  "result_url": "http://example.com",  "callback_url": "http://example.com",  "error": {    "code": "AGP_INVALID_REQUEST",    "message": "string",    "retryable": true,    "details": {}  }}
{  "error": {    "code": "AGP_INVALID_REQUEST",    "message": "string",    "retryable": true,    "details": {}  }}
{  "error": {    "code": "AGP_INVALID_REQUEST",    "message": "string",    "retryable": true,    "details": {}  }}
{  "error": {    "code": "AGP_INVALID_REQUEST",    "message": "string",    "retryable": true,    "details": {}  }}
{  "error": {    "code": "AGP_INVALID_REQUEST",    "message": "string",    "retryable": true,    "details": {}  }}
{  "error": {    "code": "AGP_INVALID_REQUEST",    "message": "string",    "retryable": true,    "details": {}  }}